Codeforces Round #370 (Div. 2) D. Memory and Scores 动态规划

D. Memory and Scores

题目连接:

http://codeforces.com/contest/712/problem/D

Description

Memory and his friend Lexa are competing to get higher score in one popular computer game. Memory starts with score a and Lexa starts with score b. In a single turn, both Memory and Lexa get some integer in the range [ - k;k] (i.e. one integer among  - k,  - k + 1,  - k + 2, …,  - 2,  - 1, 0, 1, 2, …, k - 1, k) and add them to their current scores. The game has exactly t turns. Memory and Lexa, however, are not good at this game, so they both always get a random integer at their turn.

Memory wonders how many possible games exist such that he ends with a strictly higher score than Lexa. Two games are considered to be different if in at least one turn at least one player gets different score. There are (2k + 1)2t games in total. Since the answer can be very large, you should print it modulo 109 + 7. Please solve this problem for Memory.

Input

The first and only line of input contains the four integers a, b, k, and t (1 ≤ a, b ≤ 100, 1 ≤ k ≤ 1000, 1 ≤ t ≤ 100) — the amount Memory and Lexa start with, the number k, and the number of turns respectively.

Output

Print the number of possible games satisfying the conditions modulo 1 000 000 007 (109 + 7) in one line.

Sample Input

1 2 2 1

Sample Output

6

Hint

题意

有两个人在玩游戏,一开始分数分别为a和b,每一局,每个人可以获得分数[-k,k]之间,问你A胜过B的方案数有多少种

题解:

dp[i][j]表示第i轮之后,获得j分数的方案数。

显然这个只会和上一轮有关,所以可以滚动数组优化,又显然可以前缀和优化。

然后维护一下DP

最后再枚举A的分数,统计一下答案就好了。

代码

#include<bits/stdc++.h>
using namespace std;
const int maxn = 4e5+7;
const int le = 2e5;
const int mod = 1e9+7;
long long a,b,k,t;
long long dp[2][maxn];
long long sum[maxn];
int now=0,pre=1;
int main()
{
    scanf("%lld%lld%lld%lld",&a,&b,&k,&t);
    dp[now][le]=1;
    for(int i=1;i<=t;i++)
    {
        for(int j=1;j<maxn;j++)
        {
            sum[j]=dp[now][j]+sum[j-1];
            sum[j]%=mod;
        }
        swap(now,pre);
        memset(dp[now],0,sizeof(dp[now]));
        for(int j=1;j<maxn;j++)
        {
            dp[now][j]+=sum[min(maxn-1LL,j+k)]-sum[max(0LL,j-k-1)];
            dp[now][j]%=mod;
        }
    }
    for(int j=1;j<maxn;j++)
    {
        sum[j]=dp[now][j]+sum[j-1];
        sum[j]%=mod;
    }
    long long ans = 0;
    for(int j=0;j<maxn;j++)
    {
        ans += sum[a+j-b-1]%mod*dp[now][j]%mod;
        ans%=mod;
    }
    cout<<(ans+mod)%mod<<endl;
}
    原文作者:qscqesze
    原文地址: https://www.cnblogs.com/qscqesze/p/5867961.html
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞